=== debian/changelog ===
ros-r2b3-rcl (0.0.3-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- William Woodall <william@osrfoundation.org>  Wed, 13 Sep 2017 23:54:18 -0000
