=== debian/control ===
Source: ros-r2b3-rcl
Section: misc
Priority: extra
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-r2b3-ament-cmake-gtest, ros-r2b3-ament-cmake-nose, ros-r2b3-ament-cmake-ros, ros-r2b3-ament-lint-auto, ros-r2b3-ament-lint-common, ros-r2b3-example-interfaces, ros-r2b3-launch, ros-r2b3-rcl-interfaces, ros-r2b3-rcutils, ros-r2b3-rmw, ros-r2b3-rmw-implementation, ros-r2b3-rmw-implementation-cmake, ros-r2b3-rosidl-generator-c, ros-r2b3-std-msgs, ros-r2b3-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-r2b3-rcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-r2b3-ament-cmake, ros-r2b3-rcl-interfaces, ros-r2b3-rcutils, ros-r2b3-rmw, ros-r2b3-rmw-implementation, ros-r2b3-rosidl-default-runtime, ros-r2b3-rosidl-generator-c, ros-r2b3-ros-workspace
Description: The ROS client library common implementation.
 This package contains an API which builds on the ROS middleware API and is optionally built upon by the other ROS client libraries.
